;---------------------------------------;
; Dialog as Main Example,  Version 1.0  ;
; Paul Brennick                         ;
; pebrennick@verizon.net                ;
; http://www.pbrennick.com              ;
;---------------------------------------;
        .386                            ; Minimum requirement
        .model  flat, stdcall           ; 32 bit memory model
        option  casemap :none           ; Case sensitive

;       Include Files
;       --------------------------------
        include \GeneSys\include\windows.inc
        include \GeneSys\include\user32.inc
        include \GeneSys\include\kernel32.inc
        include \GeneSys\include\gdi32.inc

;       Libraries
;       --------------------------------
        includelib  \GeneSys\lib\user32.lib
        includelib  \GeneSys\lib\kernel32.lib
        includelib  \GeneSys\lib\gdi32.lib

; Procedures
;---------------------------------------
SpecialProc     PROTO   :DWORD, :DWORD, :DWORD, :DWORD

; Macros
;---------------------------------------
RGB     macro   red, green, blue
        xor     eax, eax
        mov     ah, blue
        shl     eax, 8
        mov     ah, green
        mov     al, red
        endm

.const
;---------------------------------------
RedId           equ         1001
GreenId         equ         1002
BlueId          equ         1003
RedNo           equ         1005
GreenNo         equ         1006
BlueNo          equ         1007
CodeId          equ         1008
ViewId          equ         1009

.data
;---------------------------------------
DlgMain         db  'Special', 0
hInstance       dd  0
ColorFmt        db  "#%02X%02X%02X", 0
Hash            db  "#", 0
RedVal          dd  0
GreenVal        dd  0
BlueVal         dd  0
ColorVal        dd  0

.data?
;---------------------------------------
hControl        HANDLE      ?
hBrush          HBRUSH      ?
hdc             HDC         ?
Rect            RECT        <?>
CodeBuffer      db          7 dup (?)
Junk            db          2 dup (?)

.code
;---------------------------------------;
start:  invoke  GetModuleHandle, NULL   ; Get our app Handle from Windows
        mov     hInstance, eax          ; Store it for later use
        invoke  DialogBoxParam, hInstance, ADDR DlgMain, 0, ADDR SpecialProc, 0
        invoke  ExitProcess, eax


SpecialProc PROC  hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
;---------------------------------------
        LOCAL   code:DWORD
        LOCAL   Pos:DWORD

        .if uMsg == WM_INITDIALOG
          invoke  SendDlgItemMessage, hWin, RedId, SBM_SETRANGE, 0, 255
          invoke  SendDlgItemMessage, hWin, GreenId, SBM_SETRANGE, 0, 255
          invoke  SendDlgItemMessage, hWin, BlueId, SBM_SETRANGE, 0, 255
          ret
        .elseif uMsg == WM_CLOSE
          invoke  DeleteObject, hBrush
          invoke  EndDialog, hWin, 0
          push    1
          pop     eax
          ret
        .elseif uMsg == WM_COMMAND
          .if wParam == IDOK
            invoke  SendMessage, hWin, WM_CLOSE, 0, 0
          .endif
        .elseif uMsg==WM_HSCROLL
          invoke  RtlZeroMemory, ADDR CodeBuffer, 7
          mov     eax, wParam
          and     eax, 0FFFFh
          mov     code, eax
          mov     eax, wParam
          shr     eax, 16
          mov     Pos, eax
          .if (code==SB_THUMBPOSITION)||(code==SB_THUMBTRACK)
            invoke  SetScrollPos, lParam, SB_CTL, Pos, TRUE
            mov     eax, Pos
          .elseif code==SB_LINERIGHT
            invoke  GetScrollPos, lParam, SB_CTL
            .if eax!=255
              inc     eax
            .endif
            mov     Pos, eax
            invoke  SetScrollPos, lParam, SB_CTL, Pos, TRUE
          .elseif code==SB_LINELEFT
            invoke  GetScrollPos, lParam, SB_CTL
            .if eax!=0
              dec     eax
            .endif
            mov     Pos, eax
            invoke  SetScrollPos, lParam, SB_CTL, Pos, TRUE
          .elseif code==SB_PAGERIGHT
            invoke  GetScrollPos, lParam, SB_CTL
            add     eax, 5
            mov     Pos, eax
            invoke  SetScrollPos, lParam, SB_CTL, Pos, TRUE
          .elseif code==SB_PAGELEFT
            invoke  GetScrollPos, lParam, SB_CTL
            sub     eax, 5
            mov     Pos, eax
            invoke  SetScrollPos, lParam, SB_CTL, Pos, TRUE
          .endif
          invoke  GetWindowLong, lParam, GWL_ID
          .if eax==RedId
            invoke  GetScrollPos, lParam, SB_CTL
            mov     RedVal, eax
          .elseif eax==GreenId
            invoke  GetScrollPos, lParam, SB_CTL
            mov     GreenVal, eax
          .elseif eax==BlueId
            invoke  GetScrollPos, lParam, SB_CTL
            mov     BlueVal, eax
          .endif
          invoke  SetDlgItemInt, hWin, RedNo, RedVal, FALSE
          invoke  SetDlgItemInt, hWin, GreenNo, GreenVal, FALSE
          invoke  SetDlgItemInt, hWin, BlueNo, BlueVal, FALSE
          invoke  wsprintf, ADDR CodeBuffer, ADDR ColorFmt, RedVal, GreenVal, BlueVal
          invoke  SetDlgItemText, hWin, CodeId, ADDR CodeBuffer
          RGB     byte ptr RedVal, byte ptr GreenVal, byte ptr BlueVal
          mov     ColorVal, eax
          invoke  GetDlgItem, hWin, ViewId
          mov     hControl, eax
          invoke  GetDC, hControl
          mov     hdc, eax
          invoke  CreateSolidBrush, ColorVal
          mov     hBrush, eax
          invoke  GetClientRect, hControl, ADDR Rect
          invoke  FillRect, hdc, ADDR Rect, hBrush
          invoke  ReleaseDC, hControl, hdc
        .endif
        xor     eax, eax
        ret
;--------------------------------------
SpecialProc   endp

       end     start
